/* chess-state.c generated by valac 0.40.19, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;


#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;


#define TYPE_COLOR (color_get_type ())
typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;


#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;
typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;


#define TYPE_CHESS_RULE (chess_rule_get_type ())
typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;


#define TYPE_CHESS_RESULT (chess_result_get_type ())

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};


static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
GType chess_player_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType chess_move_get_type (void) G_GNUC_CONST;
#define CHESS_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_STATE, ChessStatePrivate))
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}


static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
	self = (ChessState*) g_object_new (object_type, NULL);
	return self;
}


static ChessState*
chess_state_new_empty (void)
{
	return chess_state_construct_empty (TYPE_CHESS_STATE);
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp52_;
	gint _tmp52__length1;
	const gchar* _tmp53_;
	gchar** _tmp60_;
	gint _tmp60__length1;
	const gchar* _tmp61_;
	gchar** _tmp76_;
	gint _tmp76__length1;
	const gchar* _tmp77_;
	gchar** _tmp82_;
	gint _tmp82__length1;
	const gchar* _tmp83_;
	gchar** _tmp84_;
	gint _tmp84__length1;
	const gchar* _tmp85_;
	ChessPlayer* _tmp86_;
	Color _tmp87_;
	ChessPlayer* _tmp89_;
	g_return_val_if_fail (fen != NULL, NULL);
	self = (ChessState*) g_object_new (object_type, NULL);
	_tmp0_ = chess_player_new (COLOR_WHITE);
	_g_object_unref0 (self->players[COLOR_WHITE]);
	self->players[COLOR_WHITE] = _tmp0_;
	_tmp1_ = chess_player_new (COLOR_BLACK);
	_g_object_unref0 (self->players[COLOR_BLACK]);
	self->players[COLOR_BLACK] = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				if (!(_tmp4_ < 64)) {
					break;
				}
				_tmp5_ = i;
				_g_object_unref0 (self->board[_tmp5_]);
				self->board[_tmp5_] = NULL;
			}
		}
	}
	_tmp7_ = _tmp6_ = g_strsplit (fen, " ", 0);
	fields = _tmp7_;
	fields_length1 = _vala_array_length (_tmp6_);
	_fields_size_ = fields_length1;
	_tmp8_ = fields;
	_tmp8__length1 = fields_length1;
	_tmp9_ = _tmp8_[0];
	_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "/", 0);
	ranks = _tmp11_;
	ranks_length1 = _vala_array_length (_tmp10_);
	_ranks_size_ = ranks_length1;
	{
		gint rank = 0;
		rank = 0;
		{
			gboolean _tmp12_ = FALSE;
			_tmp12_ = TRUE;
			while (TRUE) {
				gint _tmp14_;
				gchar* rank_string = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				gint _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				if (!_tmp12_) {
					gint _tmp13_;
					_tmp13_ = rank;
					rank = _tmp13_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp14_ = rank;
				if (!(_tmp14_ < 8)) {
					break;
				}
				_tmp15_ = ranks;
				_tmp15__length1 = ranks_length1;
				_tmp16_ = rank;
				_tmp17_ = _tmp15_[7 - _tmp16_];
				_tmp18_ = g_strdup (_tmp17_);
				rank_string = _tmp18_;
				{
					gint file = 0;
					gint offset = 0;
					file = 0;
					offset = 0;
					{
						gboolean _tmp19_ = FALSE;
						_tmp19_ = TRUE;
						while (TRUE) {
							gboolean _tmp21_ = FALSE;
							gint _tmp22_;
							gchar c = '\0';
							const gchar* _tmp27_;
							gint _tmp28_;
							gboolean _tmp29_ = FALSE;
							gchar _tmp30_;
							PieceType type = 0;
							Color _tmp34_ = 0;
							gchar _tmp35_;
							Color color = 0;
							gchar _tmp36_;
							PieceType _tmp37_ = 0;
							gint index = 0;
							gint _tmp38_;
							gint _tmp39_;
							ChessPiece* piece = NULL;
							Color _tmp40_;
							ChessPlayer* _tmp41_;
							PieceType _tmp42_;
							ChessPiece* _tmp43_;
							gint _tmp44_;
							ChessPiece* _tmp45_;
							ChessPiece* _tmp46_;
							gint64 mask = 0LL;
							gint _tmp47_;
							gint64 _tmp48_;
							Color _tmp49_;
							gint64 _tmp50_;
							gint _tmp51_;
							if (!_tmp19_) {
								gint _tmp20_;
								_tmp20_ = offset;
								offset = _tmp20_ + 1;
							}
							_tmp19_ = FALSE;
							_tmp22_ = file;
							if (_tmp22_ < 8) {
								gint _tmp23_;
								const gchar* _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
								_tmp23_ = offset;
								_tmp24_ = rank_string;
								_tmp25_ = strlen (_tmp24_);
								_tmp26_ = _tmp25_;
								_tmp21_ = _tmp23_ < _tmp26_;
							} else {
								_tmp21_ = FALSE;
							}
							if (!_tmp21_) {
								break;
							}
							_tmp27_ = rank_string;
							_tmp28_ = offset;
							c = string_get (_tmp27_, (glong) _tmp28_);
							_tmp30_ = c;
							if (_tmp30_ >= '1') {
								gchar _tmp31_;
								_tmp31_ = c;
								_tmp29_ = _tmp31_ <= '8';
							} else {
								_tmp29_ = FALSE;
							}
							if (_tmp29_) {
								gint _tmp32_;
								gchar _tmp33_;
								_tmp32_ = file;
								_tmp33_ = c;
								file = _tmp32_ + (_tmp33_ - '0');
								continue;
							}
							_tmp35_ = c;
							if (g_ascii_isupper (_tmp35_)) {
								_tmp34_ = COLOR_WHITE;
							} else {
								_tmp34_ = COLOR_BLACK;
							}
							color = _tmp34_;
							_tmp36_ = c;
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (_tmp36_), &_tmp37_);
							type = _tmp37_;
							_tmp38_ = rank;
							_tmp39_ = file;
							index = chess_state_get_index (self, _tmp38_, _tmp39_);
							_tmp40_ = color;
							_tmp41_ = self->players[_tmp40_];
							_tmp42_ = type;
							_tmp43_ = chess_piece_new (_tmp41_, _tmp42_);
							piece = _tmp43_;
							_tmp44_ = index;
							_tmp45_ = piece;
							_tmp46_ = _g_object_ref0 (_tmp45_);
							_g_object_unref0 (self->board[_tmp44_]);
							self->board[_tmp44_] = _tmp46_;
							_tmp47_ = index;
							_tmp48_ = BIT_BOARD_set_location_masks[_tmp47_];
							mask = _tmp48_;
							_tmp49_ = color;
							_tmp50_ = mask;
							self->priv->piece_masks[_tmp49_] |= _tmp50_;
							_tmp51_ = file;
							file = _tmp51_ + 1;
							_g_object_unref0 (piece);
						}
					}
				}
				_g_free0 (rank_string);
			}
		}
	}
	_tmp52_ = fields;
	_tmp52__length1 = fields_length1;
	_tmp53_ = _tmp52_[1];
	if (g_strcmp0 (_tmp53_, "w") == 0) {
		ChessPlayer* _tmp54_;
		ChessPlayer* _tmp55_;
		_tmp54_ = self->players[COLOR_WHITE];
		_tmp55_ = _g_object_ref0 (_tmp54_);
		_g_object_unref0 (self->current_player);
		self->current_player = _tmp55_;
	} else {
		gchar** _tmp56_;
		gint _tmp56__length1;
		const gchar* _tmp57_;
		_tmp56_ = fields;
		_tmp56__length1 = fields_length1;
		_tmp57_ = _tmp56_[1];
		if (g_strcmp0 (_tmp57_, "b") == 0) {
			ChessPlayer* _tmp58_;
			ChessPlayer* _tmp59_;
			_tmp58_ = self->players[COLOR_BLACK];
			_tmp59_ = _g_object_ref0 (_tmp58_);
			_g_object_unref0 (self->current_player);
			self->current_player = _tmp59_;
		}
	}
	_tmp60_ = fields;
	_tmp60__length1 = fields_length1;
	_tmp61_ = _tmp60_[2];
	if (g_strcmp0 (_tmp61_, "-") != 0) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp62_ = FALSE;
				_tmp62_ = TRUE;
				while (TRUE) {
					gint _tmp64_;
					gchar** _tmp65_;
					gint _tmp65__length1;
					const gchar* _tmp66_;
					gint _tmp67_;
					gint _tmp68_;
					gchar c = '\0';
					gchar** _tmp69_;
					gint _tmp69__length1;
					const gchar* _tmp70_;
					gint _tmp71_;
					gchar _tmp72_;
					if (!_tmp62_) {
						gint _tmp63_;
						_tmp63_ = i;
						i = _tmp63_ + 1;
					}
					_tmp62_ = FALSE;
					_tmp64_ = i;
					_tmp65_ = fields;
					_tmp65__length1 = fields_length1;
					_tmp66_ = _tmp65_[2];
					_tmp67_ = strlen (_tmp66_);
					_tmp68_ = _tmp67_;
					if (!(_tmp64_ < _tmp68_)) {
						break;
					}
					_tmp69_ = fields;
					_tmp69__length1 = fields_length1;
					_tmp70_ = _tmp69_[2];
					_tmp71_ = i;
					c = string_get (_tmp70_, (glong) _tmp71_);
					_tmp72_ = c;
					if (_tmp72_ == 'K') {
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
					} else {
						gchar _tmp73_;
						_tmp73_ = c;
						if (_tmp73_ == 'Q') {
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
						} else {
							gchar _tmp74_;
							_tmp74_ = c;
							if (_tmp74_ == 'k') {
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
							} else {
								gchar _tmp75_;
								_tmp75_ = c;
								if (_tmp75_ == 'q') {
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp76_ = fields;
	_tmp76__length1 = fields_length1;
	_tmp77_ = _tmp76_[3];
	if (g_strcmp0 (_tmp77_, "-") != 0) {
		gchar** _tmp78_;
		gint _tmp78__length1;
		const gchar* _tmp79_;
		gchar** _tmp80_;
		gint _tmp80__length1;
		const gchar* _tmp81_;
		_tmp78_ = fields;
		_tmp78__length1 = fields_length1;
		_tmp79_ = _tmp78_[3];
		_tmp80_ = fields;
		_tmp80__length1 = fields_length1;
		_tmp81_ = _tmp80_[3];
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp79_, (glong) 1) - '1'), (gint) (string_get (_tmp81_, (glong) 0) - 'a'));
	}
	_tmp82_ = fields;
	_tmp82__length1 = fields_length1;
	_tmp83_ = _tmp82_[4];
	self->halfmove_clock = atoi (_tmp83_);
	_tmp84_ = fields;
	_tmp84__length1 = fields_length1;
	_tmp85_ = _tmp84_[5];
	self->number = (atoi (_tmp85_) - 1) * 2;
	_tmp86_ = self->current_player;
	_tmp87_ = _tmp86_->color;
	if (_tmp87_ == COLOR_BLACK) {
		gint _tmp88_;
		_tmp88_ = self->number;
		self->number = _tmp88_ + 1;
	}
	_tmp89_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp89_);
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


ChessState*
chess_state_new (const gchar* fen)
{
	return chess_state_construct (TYPE_CHESS_STATE, fen);
}


ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* result = NULL;
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
	ChessState* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessPlayer* _tmp5_;
	ChessState* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessPlayer* _tmp8_;
	ChessState* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessPlayer* _tmp11_;
	ChessState* _tmp12_;
	gboolean _tmp13_;
	ChessState* _tmp14_;
	gboolean _tmp15_;
	ChessState* _tmp16_;
	gboolean _tmp17_;
	ChessState* _tmp18_;
	gboolean _tmp19_;
	ChessState* _tmp20_;
	gint _tmp21_;
	ChessState* _tmp22_;
	CheckState _tmp23_;
	ChessMove* _tmp24_;
	ChessState* _tmp36_;
	gint64 _tmp37_;
	ChessState* _tmp38_;
	gint64 _tmp39_;
	ChessState* _tmp40_;
	gint _tmp41_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = chess_state_new_empty ();
	state = _tmp0_;
	_tmp1_ = state;
	_tmp2_ = self->number;
	_tmp1_->number = _tmp2_;
	_tmp3_ = state;
	_tmp4_ = self->players[COLOR_WHITE];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (_tmp3_->players[COLOR_WHITE]);
	_tmp3_->players[COLOR_WHITE] = _tmp5_;
	_tmp6_ = state;
	_tmp7_ = self->players[COLOR_BLACK];
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_g_object_unref0 (_tmp6_->players[COLOR_BLACK]);
	_tmp6_->players[COLOR_BLACK] = _tmp8_;
	_tmp9_ = state;
	_tmp10_ = self->current_player;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (_tmp9_->current_player);
	_tmp9_->current_player = _tmp11_;
	_tmp12_ = state;
	_tmp13_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp12_->can_castle_kingside[COLOR_WHITE] = _tmp13_;
	_tmp14_ = state;
	_tmp15_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp14_->can_castle_queenside[COLOR_WHITE] = _tmp15_;
	_tmp16_ = state;
	_tmp17_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp16_->can_castle_kingside[COLOR_BLACK] = _tmp17_;
	_tmp18_ = state;
	_tmp19_ = self->can_castle_queenside[COLOR_BLACK];
	_tmp18_->can_castle_queenside[COLOR_BLACK] = _tmp19_;
	_tmp20_ = state;
	_tmp21_ = self->en_passant_index;
	_tmp20_->en_passant_index = _tmp21_;
	_tmp22_ = state;
	_tmp23_ = self->check_state;
	_tmp22_->check_state = _tmp23_;
	_tmp24_ = self->last_move;
	if (_tmp24_ != NULL) {
		ChessState* _tmp25_;
		ChessMove* _tmp26_;
		ChessMove* _tmp27_;
		_tmp25_ = state;
		_tmp26_ = self->last_move;
		_tmp27_ = chess_move_copy (_tmp26_);
		_g_object_unref0 (_tmp25_->last_move);
		_tmp25_->last_move = _tmp27_;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				gint _tmp30_;
				ChessState* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				ChessPiece* _tmp34_;
				ChessPiece* _tmp35_;
				if (!_tmp28_) {
					gint _tmp29_;
					_tmp29_ = i;
					i = _tmp29_ + 1;
				}
				_tmp28_ = FALSE;
				_tmp30_ = i;
				if (!(_tmp30_ < 64)) {
					break;
				}
				_tmp31_ = state;
				_tmp32_ = i;
				_tmp33_ = i;
				_tmp34_ = self->board[_tmp33_];
				_tmp35_ = _g_object_ref0 (_tmp34_);
				_g_object_unref0 (_tmp31_->board[_tmp32_]);
				_tmp31_->board[_tmp32_] = _tmp35_;
			}
		}
	}
	_tmp36_ = state;
	_tmp37_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp36_->priv->piece_masks[COLOR_WHITE] = _tmp37_;
	_tmp38_ = state;
	_tmp39_ = self->priv->piece_masks[COLOR_BLACK];
	_tmp38_->priv->piece_masks[COLOR_BLACK] = _tmp39_;
	_tmp40_ = state;
	_tmp41_ = self->halfmove_clock;
	_tmp40_->halfmove_clock = _tmp41_;
	result = state;
	return result;
}


gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (state != NULL, FALSE);
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
	if (_tmp7_ != _tmp8_) {
		_tmp6_ = TRUE;
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
		_tmp6_ = _tmp9_ != _tmp10_;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
		_tmp11_ = self->current_player;
		_tmp12_ = _tmp11_->color;
		_tmp13_ = state->current_player;
		_tmp14_ = _tmp13_->color;
		_tmp5_ = _tmp12_ != _tmp14_;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
		_tmp4_ = _tmp15_ != _tmp16_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
		_tmp3_ = _tmp17_ != _tmp18_;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
		_tmp2_ = _tmp19_ != _tmp20_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
		_tmp1_ = _tmp21_ != _tmp22_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp23_;
		gint _tmp24_;
		_tmp23_ = self->en_passant_index;
		_tmp24_ = state->en_passant_index;
		_tmp0_ = _tmp23_ != _tmp24_;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				ChessPiece* _tmp30_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = i;
				if (!(_tmp27_ < 64)) {
					break;
				}
				_tmp29_ = i;
				_tmp30_ = self->board[_tmp29_];
				if (_tmp30_ != NULL) {
					gint _tmp31_;
					ChessPiece* _tmp32_;
					PieceType _tmp33_;
					gint _tmp34_;
					ChessPiece* _tmp35_;
					PieceType _tmp36_;
					_tmp31_ = i;
					_tmp32_ = self->board[_tmp31_];
					_tmp33_ = _tmp32_->type;
					_tmp34_ = i;
					_tmp35_ = state->board[_tmp34_];
					_tmp36_ = _tmp35_->type;
					_tmp28_ = _tmp33_ != _tmp36_;
				} else {
					_tmp28_ = FALSE;
				}
				if (_tmp28_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


gchar*
chess_state_get_fen (ChessState* self)
{
	gchar* result = NULL;
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp25_;
	ChessPlayer* _tmp26_;
	Color _tmp27_;
	GString* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp33_;
	gboolean _tmp35_;
	gboolean _tmp37_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GString* _tmp44_;
	gint _tmp45_;
	GString* _tmp50_;
	GString* _tmp51_;
	gint _tmp52_;
	GString* _tmp53_;
	ChessPlayer* _tmp54_;
	Color _tmp55_;
	GString* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	value = _tmp0_;
	{
		gint rank = 0;
		rank = 7;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint skip_count = 0;
				gint _tmp20_;
				gint _tmp23_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = rank;
					rank = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = rank;
				if (!(_tmp3_ >= 0)) {
					break;
				}
				skip_count = 0;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gint _tmp6_;
							ChessPiece* p = NULL;
							gint _tmp7_;
							gint _tmp8_;
							ChessPiece* _tmp9_;
							ChessPiece* _tmp10_;
							ChessPiece* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = file;
								file = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = file;
							if (!(_tmp6_ < 8)) {
								break;
							}
							_tmp7_ = rank;
							_tmp8_ = file;
							_tmp9_ = self->board[chess_state_get_index (self, _tmp7_, _tmp8_)];
							_tmp10_ = _g_object_ref0 (_tmp9_);
							p = _tmp10_;
							_tmp11_ = p;
							if (_tmp11_ == NULL) {
								gint _tmp12_;
								_tmp12_ = skip_count;
								skip_count = _tmp12_ + 1;
							} else {
								gint _tmp13_;
								GString* _tmp16_;
								ChessPiece* _tmp17_;
								gunichar _tmp18_;
								gunichar _tmp19_;
								_tmp13_ = skip_count;
								if (_tmp13_ > 0) {
									GString* _tmp14_;
									gint _tmp15_;
									_tmp14_ = value;
									_tmp15_ = skip_count;
									g_string_append_printf (_tmp14_, "%d", _tmp15_);
									skip_count = 0;
								}
								_tmp16_ = value;
								_tmp17_ = p;
								_tmp18_ = chess_piece_get_symbol (_tmp17_);
								_tmp19_ = _tmp18_;
								g_string_append_printf (_tmp16_, "%c", (gint) _tmp19_);
							}
							_g_object_unref0 (p);
						}
					}
				}
				_tmp20_ = skip_count;
				if (_tmp20_ > 0) {
					GString* _tmp21_;
					gint _tmp22_;
					_tmp21_ = value;
					_tmp22_ = skip_count;
					g_string_append_printf (_tmp21_, "%d", _tmp22_);
				}
				_tmp23_ = rank;
				if (_tmp23_ != 0) {
					GString* _tmp24_;
					_tmp24_ = value;
					g_string_append_c (_tmp24_, '/');
				}
			}
		}
	}
	_tmp25_ = value;
	g_string_append_c (_tmp25_, ' ');
	_tmp26_ = self->current_player;
	_tmp27_ = _tmp26_->color;
	if (_tmp27_ == COLOR_WHITE) {
		GString* _tmp28_;
		_tmp28_ = value;
		g_string_append_c (_tmp28_, 'w');
	} else {
		GString* _tmp29_;
		_tmp29_ = value;
		g_string_append_c (_tmp29_, 'b');
	}
	_tmp30_ = value;
	g_string_append_c (_tmp30_, ' ');
	_tmp31_ = self->can_castle_kingside[COLOR_WHITE];
	if (_tmp31_) {
		GString* _tmp32_;
		_tmp32_ = value;
		g_string_append_c (_tmp32_, 'K');
	}
	_tmp33_ = self->can_castle_queenside[COLOR_WHITE];
	if (_tmp33_) {
		GString* _tmp34_;
		_tmp34_ = value;
		g_string_append_c (_tmp34_, 'Q');
	}
	_tmp35_ = self->can_castle_kingside[COLOR_BLACK];
	if (_tmp35_) {
		GString* _tmp36_;
		_tmp36_ = value;
		g_string_append_c (_tmp36_, 'k');
	}
	_tmp37_ = self->can_castle_queenside[COLOR_BLACK];
	if (_tmp37_) {
		GString* _tmp38_;
		_tmp38_ = value;
		g_string_append_c (_tmp38_, 'q');
	}
	_tmp39_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp40_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp41_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp42_ = self->can_castle_queenside[COLOR_BLACK];
	if (!(((_tmp39_ | _tmp40_) | _tmp41_) | _tmp42_)) {
		GString* _tmp43_;
		_tmp43_ = value;
		g_string_append_c (_tmp43_, '-');
	}
	_tmp44_ = value;
	g_string_append_c (_tmp44_, ' ');
	_tmp45_ = self->en_passant_index;
	if (_tmp45_ >= 0) {
		GString* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		_tmp46_ = value;
		_tmp47_ = self->en_passant_index;
		_tmp48_ = self->en_passant_index;
		g_string_append_printf (_tmp46_, "%c%d", 'a' + chess_state_get_file (self, _tmp47_), chess_state_get_rank (self, _tmp48_) + 1);
	} else {
		GString* _tmp49_;
		_tmp49_ = value;
		g_string_append_c (_tmp49_, '-');
	}
	_tmp50_ = value;
	g_string_append_c (_tmp50_, ' ');
	_tmp51_ = value;
	_tmp52_ = self->halfmove_clock;
	g_string_append_printf (_tmp51_, "%d", _tmp52_);
	_tmp53_ = value;
	g_string_append_c (_tmp53_, ' ');
	_tmp54_ = self->current_player;
	_tmp55_ = _tmp54_->color;
	if (_tmp55_ == COLOR_WHITE) {
		GString* _tmp56_;
		gint _tmp57_;
		_tmp56_ = value;
		_tmp57_ = self->number;
		g_string_append_printf (_tmp56_, "%d", _tmp57_ / 2);
	} else {
		GString* _tmp58_;
		gint _tmp59_;
		_tmp58_ = value;
		_tmp59_ = self->number;
		g_string_append_printf (_tmp58_, "%d", (_tmp59_ / 2) + 1);
	}
	_tmp60_ = value;
	_tmp61_ = _tmp60_->str;
	_tmp62_ = g_strdup (_tmp61_);
	result = _tmp62_;
	_g_string_free0 (value);
	return result;
}


gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = (rank * 8) + file;
	return result;
}


gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index / 8;
	return result;
}


gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index % 8;
	return result;
}


gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gboolean result = FALSE;
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PieceType _tmp12_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	_tmp0_ = self->current_player;
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	r0 = _tmp1_;
	f0 = _tmp2_;
	r1 = _tmp3_;
	f1 = _tmp4_;
	promotion_type = _tmp5_;
	if (!_tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = self->current_player;
	_tmp8_ = r0;
	_tmp9_ = f0;
	_tmp10_ = r1;
	_tmp11_ = f1;
	_tmp12_ = promotion_type;
	if (!chess_state_move_with_coords (self, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_, apply, TRUE)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gboolean result = FALSE;
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	gint _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ChessPiece* _tmp7_;
	gint64 end_mask = 0LL;
	gint _tmp10_;
	gint64 _tmp11_;
	gint64 move_mask = 0LL;
	Color _tmp12_;
	ChessPiece* _tmp13_;
	PieceType _tmp14_;
	gint _tmp15_;
	gint64 _tmp16_;
	gint64 _tmp17_;
	gint64 _tmp18_;
	gint64 over_mask = 0LL;
	gint _tmp19_;
	gint _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_;
	gint64 _tmp23_;
	gint64 _tmp24_;
	ChessPiece* victim = NULL;
	gint _tmp25_;
	ChessPiece* _tmp26_;
	ChessPiece* _tmp27_;
	gint victim_index = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	ChessPiece* _tmp30_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp33_;
	PieceType _tmp34_;
	gboolean _tmp74_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp98_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp99_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp100_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp101_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp102_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp103_;
	gint old_en_passant_index = 0;
	gint _tmp104_;
	gint old_halfmove_clock = 0;
	gint _tmp105_;
	gint _tmp106_;
	gint _tmp107_;
	gint64 _tmp108_;
	gint _tmp109_;
	gint64 _tmp110_;
	ChessPiece* _tmp111_;
	gboolean _tmp117_;
	Color _tmp123_;
	gint64 _tmp124_;
	Color _tmp125_;
	gint _tmp126_;
	gint64 _tmp127_;
	gint _tmp128_;
	ChessPiece* _tmp142_;
	PieceType _tmp143_;
	gboolean _tmp162_ = FALSE;
	ChessPiece* _tmp163_;
	PieceType _tmp164_;
	gboolean _tmp166_ = FALSE;
	ChessPiece* _tmp167_;
	PieceType _tmp168_;
	gboolean _result_ = FALSE;
	gboolean _tmp171_ = FALSE;
	gboolean _tmp172_ = FALSE;
	ChessPlayer* _tmp198_ = NULL;
	Color _tmp199_;
	ChessPlayer* _tmp202_;
	ChessPlayer* _tmp203_;
	ChessMove* _tmp204_;
	ChessMove* _tmp205_;
	gint _tmp206_;
	ChessMove* _tmp207_;
	ChessPiece* _tmp208_;
	ChessPiece* _tmp209_;
	gboolean _tmp210_;
	ChessMove* _tmp215_;
	ChessPiece* _tmp216_;
	ChessPiece* _tmp217_;
	gint _tmp218_;
	ChessMove* _tmp223_;
	ChessMove* _tmp224_;
	ChessMove* _tmp225_;
	ChessMove* _tmp226_;
	ChessMove* _tmp227_;
	gboolean _tmp228_;
	ChessMove* _tmp229_;
	gboolean _tmp230_;
	ChessMove* _tmp231_;
	gboolean _tmp232_;
	ChessMove* _tmp233_;
	CheckState _tmp234_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	start = chess_state_get_index (self, r0, f0);
	end = chess_state_get_index (self, r1, f1);
	_tmp0_ = player->color;
	color = _tmp0_;
	_tmp2_ = color;
	if (_tmp2_ == COLOR_WHITE) {
		_tmp1_ = COLOR_BLACK;
	} else {
		_tmp1_ = COLOR_WHITE;
	}
	opponent_color = _tmp1_;
	_tmp3_ = start;
	_tmp4_ = self->board[_tmp3_];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	piece = _tmp5_;
	_tmp7_ = piece;
	if (_tmp7_ == NULL) {
		_tmp6_ = TRUE;
	} else {
		ChessPiece* _tmp8_;
		ChessPlayer* _tmp9_;
		_tmp8_ = piece;
		_tmp9_ = _tmp8_->player;
		_tmp6_ = _tmp9_ != player;
	}
	if (_tmp6_) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp10_ = end;
	_tmp11_ = BIT_BOARD_set_location_masks[_tmp10_];
	end_mask = _tmp11_;
	_tmp12_ = color;
	_tmp13_ = piece;
	_tmp14_ = _tmp13_->type;
	_tmp15_ = start;
	_tmp16_ = BIT_BOARD_move_masks[(((_tmp12_ * 64) * 6) + (_tmp14_ * 64)) + _tmp15_];
	move_mask = _tmp16_;
	_tmp17_ = end_mask;
	_tmp18_ = move_mask;
	if ((_tmp17_ & _tmp18_) == ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp19_ = start;
	_tmp20_ = end;
	_tmp21_ = BIT_BOARD_over_masks[(_tmp19_ * 64) + _tmp20_];
	over_mask = _tmp21_;
	_tmp22_ = over_mask;
	_tmp23_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp24_ = self->priv->piece_masks[COLOR_BLACK];
	if ((_tmp22_ & (_tmp23_ | _tmp24_)) != ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp25_ = end;
	_tmp26_ = self->board[_tmp25_];
	_tmp27_ = _g_object_ref0 (_tmp26_);
	victim = _tmp27_;
	_tmp28_ = end;
	victim_index = _tmp28_;
	_tmp30_ = victim;
	if (_tmp30_ != NULL) {
		ChessPiece* _tmp31_;
		ChessPlayer* _tmp32_;
		_tmp31_ = victim;
		_tmp32_ = _tmp31_->player;
		_tmp29_ = _tmp32_ == player;
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		result = FALSE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	rook_start = -1;
	rook_end = -1;
	is_promotion = FALSE;
	en_passant = FALSE;
	ambiguous_rank = FALSE;
	ambiguous_file = FALSE;
	_tmp33_ = piece;
	_tmp34_ = _tmp33_->type;
	switch (_tmp34_) {
		case PIECE_TYPE_PAWN:
		{
			gboolean _tmp35_ = FALSE;
			ChessPiece* _tmp36_;
			gboolean _tmp45_ = FALSE;
			ChessPiece* _tmp46_;
			_tmp36_ = victim;
			if (_tmp36_ == NULL) {
				gint _tmp37_;
				gint _tmp38_;
				_tmp37_ = end;
				_tmp38_ = self->en_passant_index;
				_tmp35_ = _tmp37_ == _tmp38_;
			} else {
				_tmp35_ = FALSE;
			}
			if (_tmp35_) {
				gint _tmp39_ = 0;
				gint _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
				en_passant = TRUE;
				if (r1 == 2) {
					_tmp39_ = 3;
				} else {
					_tmp39_ = 4;
				}
				victim_index = chess_state_get_index (self, _tmp39_, f1);
				_tmp40_ = victim_index;
				_tmp41_ = self->board[_tmp40_];
				_tmp42_ = _g_object_ref0 (_tmp41_);
				_g_object_unref0 (victim);
				victim = _tmp42_;
			}
			if (f0 != f1) {
				ChessPiece* _tmp43_;
				_tmp43_ = victim;
				if (_tmp43_ == NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			} else {
				ChessPiece* _tmp44_;
				_tmp44_ = victim;
				if (_tmp44_ != NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			}
			if (r1 == 0) {
				_tmp45_ = TRUE;
			} else {
				_tmp45_ = r1 == 7;
			}
			is_promotion = _tmp45_;
			_tmp46_ = victim;
			if (_tmp46_ != NULL) {
				ambiguous_file = TRUE;
			}
			break;
		}
		case PIECE_TYPE_KING:
		{
			if (abs (f0 - f1) > 1) {
				gint _tmp47_ = 0;
				gint _tmp48_ = 0;
				ChessPiece* rook = NULL;
				gint _tmp53_;
				ChessPiece* _tmp54_;
				ChessPiece* _tmp55_;
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				ChessPiece* _tmp58_;
				gint64 rook_over_mask = 0LL;
				gint _tmp65_;
				gint _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				gint64 _tmp70_;
				CheckState _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
				if (f1 > f0) {
					_tmp47_ = 7;
				} else {
					_tmp47_ = 0;
				}
				rook_start = chess_state_get_index (self, r0, _tmp47_);
				if (f1 > f0) {
					_tmp48_ = f1 - 1;
				} else {
					_tmp48_ = f1 + 1;
				}
				rook_end = chess_state_get_index (self, r0, _tmp48_);
				if (f1 > f0) {
					Color _tmp49_;
					gboolean _tmp50_;
					_tmp49_ = color;
					_tmp50_ = self->can_castle_kingside[_tmp49_];
					if (!_tmp50_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				} else {
					Color _tmp51_;
					gboolean _tmp52_;
					_tmp51_ = color;
					_tmp52_ = self->can_castle_queenside[_tmp51_];
					if (!_tmp52_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				}
				_tmp53_ = rook_start;
				_tmp54_ = self->board[_tmp53_];
				_tmp55_ = _g_object_ref0 (_tmp54_);
				rook = _tmp55_;
				_tmp58_ = rook;
				if (_tmp58_ == NULL) {
					_tmp57_ = TRUE;
				} else {
					ChessPiece* _tmp59_;
					PieceType _tmp60_;
					_tmp59_ = rook;
					_tmp60_ = _tmp59_->type;
					_tmp57_ = _tmp60_ != PIECE_TYPE_ROOK;
				}
				if (_tmp57_) {
					_tmp56_ = TRUE;
				} else {
					ChessPiece* _tmp61_;
					Color _tmp62_;
					Color _tmp63_;
					Color _tmp64_;
					_tmp61_ = rook;
					_tmp62_ = chess_piece_get_color (_tmp61_);
					_tmp63_ = _tmp62_;
					_tmp64_ = color;
					_tmp56_ = _tmp63_ != _tmp64_;
				}
				if (_tmp56_) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp65_ = rook_start;
				_tmp66_ = rook_end;
				_tmp67_ = BIT_BOARD_over_masks[(_tmp65_ * 64) + _tmp66_];
				rook_over_mask = _tmp67_;
				_tmp68_ = rook_over_mask;
				_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
				_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
				if ((_tmp68_ & (_tmp69_ | _tmp70_)) != ((gint64) 0)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp71_ = self->check_state;
				if (_tmp71_ == CHECK_STATE_CHECK) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp72_ = rook_end;
				_tmp73_ = rook_end;
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, _tmp72_), chess_state_get_file (self, _tmp73_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_g_object_unref0 (rook);
			}
			break;
		}
		default:
		{
			break;
		}
	}
	if (!apply) {
		_tmp74_ = !test_check;
	} else {
		_tmp74_ = FALSE;
	}
	if (_tmp74_) {
		result = TRUE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	if (apply) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp75_ = FALSE;
				_tmp75_ = TRUE;
				while (TRUE) {
					gint _tmp77_;
					gint _tmp78_;
					gint _tmp79_;
					ChessPiece* p = NULL;
					gint _tmp80_;
					ChessPiece* _tmp81_;
					ChessPiece* _tmp82_;
					gboolean _tmp83_ = FALSE;
					gboolean _tmp84_ = FALSE;
					ChessPiece* _tmp85_;
					gint r = 0;
					gint _tmp92_;
					gint f = 0;
					gint _tmp93_;
					gint _tmp94_;
					gint _tmp95_;
					if (!_tmp75_) {
						gint _tmp76_;
						_tmp76_ = i;
						i = _tmp76_ + 1;
					}
					_tmp75_ = FALSE;
					_tmp77_ = i;
					if (!(_tmp77_ < 64)) {
						break;
					}
					_tmp78_ = i;
					_tmp79_ = start;
					if (_tmp78_ == _tmp79_) {
						continue;
					}
					_tmp80_ = i;
					_tmp81_ = self->board[_tmp80_];
					_tmp82_ = _g_object_ref0 (_tmp81_);
					p = _tmp82_;
					_tmp85_ = p;
					if (_tmp85_ == NULL) {
						_tmp84_ = TRUE;
					} else {
						ChessPiece* _tmp86_;
						ChessPlayer* _tmp87_;
						_tmp86_ = p;
						_tmp87_ = _tmp86_->player;
						_tmp84_ = _tmp87_ != player;
					}
					if (_tmp84_) {
						_tmp83_ = TRUE;
					} else {
						ChessPiece* _tmp88_;
						PieceType _tmp89_;
						ChessPiece* _tmp90_;
						PieceType _tmp91_;
						_tmp88_ = p;
						_tmp89_ = _tmp88_->type;
						_tmp90_ = piece;
						_tmp91_ = _tmp90_->type;
						_tmp83_ = _tmp89_ != _tmp91_;
					}
					if (_tmp83_) {
						_g_object_unref0 (p);
						continue;
					}
					_tmp92_ = i;
					r = chess_state_get_rank (self, _tmp92_);
					_tmp93_ = i;
					f = chess_state_get_file (self, _tmp93_);
					_tmp94_ = r;
					_tmp95_ = f;
					if (chess_state_move_with_coords (self, player, _tmp94_, _tmp95_, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
						gint _tmp96_;
						gint _tmp97_;
						_tmp96_ = r;
						if (_tmp96_ != r0) {
							ambiguous_rank = TRUE;
						}
						_tmp97_ = f;
						if (_tmp97_ != f0) {
							ambiguous_file = TRUE;
						}
					}
					_g_object_unref0 (p);
				}
			}
		}
	}
	_tmp98_ = self->priv->piece_masks[COLOR_WHITE];
	old_white_mask = _tmp98_;
	_tmp99_ = self->priv->piece_masks[COLOR_BLACK];
	old_black_mask = _tmp99_;
	_tmp100_ = self->can_castle_kingside[COLOR_WHITE];
	old_white_can_castle_kingside = _tmp100_;
	_tmp101_ = self->can_castle_queenside[COLOR_WHITE];
	old_white_can_castle_queenside = _tmp101_;
	_tmp102_ = self->can_castle_kingside[COLOR_BLACK];
	old_black_can_castle_kingside = _tmp102_;
	_tmp103_ = self->can_castle_queenside[COLOR_BLACK];
	old_black_can_castle_queenside = _tmp103_;
	_tmp104_ = self->en_passant_index;
	old_en_passant_index = _tmp104_;
	_tmp105_ = self->halfmove_clock;
	old_halfmove_clock = _tmp105_;
	_tmp106_ = start;
	_g_object_unref0 (self->board[_tmp106_]);
	self->board[_tmp106_] = NULL;
	_tmp107_ = start;
	_tmp108_ = BIT_BOARD_clear_location_masks[_tmp107_];
	self->priv->piece_masks[COLOR_WHITE] &= _tmp108_;
	_tmp109_ = start;
	_tmp110_ = BIT_BOARD_clear_location_masks[_tmp109_];
	self->priv->piece_masks[COLOR_BLACK] &= _tmp110_;
	_tmp111_ = victim;
	if (_tmp111_ != NULL) {
		gint _tmp112_;
		gint _tmp113_;
		gint64 _tmp114_;
		gint _tmp115_;
		gint64 _tmp116_;
		_tmp112_ = victim_index;
		_g_object_unref0 (self->board[_tmp112_]);
		self->board[_tmp112_] = NULL;
		_tmp113_ = victim_index;
		_tmp114_ = BIT_BOARD_clear_location_masks[_tmp113_];
		self->priv->piece_masks[COLOR_WHITE] &= _tmp114_;
		_tmp115_ = victim_index;
		_tmp116_ = BIT_BOARD_clear_location_masks[_tmp115_];
		self->priv->piece_masks[COLOR_BLACK] &= _tmp116_;
	}
	_tmp117_ = is_promotion;
	if (_tmp117_) {
		gint _tmp118_;
		ChessPiece* _tmp119_;
		_tmp118_ = end;
		_tmp119_ = chess_piece_new (player, promotion_type);
		_g_object_unref0 (self->board[_tmp118_]);
		self->board[_tmp118_] = _tmp119_;
	} else {
		gint _tmp120_;
		ChessPiece* _tmp121_;
		ChessPiece* _tmp122_;
		_tmp120_ = end;
		_tmp121_ = piece;
		_tmp122_ = _g_object_ref0 (_tmp121_);
		_g_object_unref0 (self->board[_tmp120_]);
		self->board[_tmp120_] = _tmp122_;
	}
	_tmp123_ = color;
	_tmp124_ = end_mask;
	self->priv->piece_masks[_tmp123_] |= _tmp124_;
	_tmp125_ = opponent_color;
	_tmp126_ = end;
	_tmp127_ = BIT_BOARD_clear_location_masks[_tmp126_];
	self->priv->piece_masks[_tmp125_] &= _tmp127_;
	_tmp128_ = rook_start;
	if (_tmp128_ >= 0) {
		ChessPiece* rook = NULL;
		gint _tmp129_;
		ChessPiece* _tmp130_;
		ChessPiece* _tmp131_;
		gint _tmp132_;
		Color _tmp133_;
		gint _tmp134_;
		gint64 _tmp135_;
		gint _tmp136_;
		ChessPiece* _tmp137_;
		ChessPiece* _tmp138_;
		Color _tmp139_;
		gint _tmp140_;
		gint64 _tmp141_;
		_tmp129_ = rook_start;
		_tmp130_ = self->board[_tmp129_];
		_tmp131_ = _g_object_ref0 (_tmp130_);
		rook = _tmp131_;
		_tmp132_ = rook_start;
		_g_object_unref0 (self->board[_tmp132_]);
		self->board[_tmp132_] = NULL;
		_tmp133_ = color;
		_tmp134_ = rook_start;
		_tmp135_ = BIT_BOARD_clear_location_masks[_tmp134_];
		self->priv->piece_masks[_tmp133_] &= _tmp135_;
		_tmp136_ = rook_end;
		_tmp137_ = rook;
		_tmp138_ = _g_object_ref0 (_tmp137_);
		_g_object_unref0 (self->board[_tmp136_]);
		self->board[_tmp136_] = _tmp138_;
		_tmp139_ = color;
		_tmp140_ = rook_end;
		_tmp141_ = BIT_BOARD_set_location_masks[_tmp140_];
		self->priv->piece_masks[_tmp139_] |= _tmp141_;
		_g_object_unref0 (rook);
	}
	_tmp142_ = piece;
	_tmp143_ = _tmp142_->type;
	if (_tmp143_ == PIECE_TYPE_KING) {
		Color _tmp144_;
		Color _tmp145_;
		_tmp144_ = color;
		self->can_castle_kingside[_tmp144_] = FALSE;
		_tmp145_ = color;
		self->can_castle_queenside[_tmp145_] = FALSE;
	} else {
		ChessPiece* _tmp146_;
		PieceType _tmp147_;
		_tmp146_ = piece;
		_tmp147_ = _tmp146_->type;
		if (_tmp147_ == PIECE_TYPE_ROOK) {
			gint _tmp148_ = 0;
			Color _tmp149_;
			gint base_rank = 0;
			gint _tmp150_;
			_tmp149_ = color;
			if (_tmp149_ == COLOR_WHITE) {
				_tmp148_ = 0;
			} else {
				_tmp148_ = 7;
			}
			base_rank = _tmp148_;
			_tmp150_ = base_rank;
			if (r0 == _tmp150_) {
				if (f0 == 0) {
					Color _tmp151_;
					_tmp151_ = color;
					self->can_castle_queenside[_tmp151_] = FALSE;
				} else {
					if (f0 == 7) {
						Color _tmp152_;
						_tmp152_ = color;
						self->can_castle_kingside[_tmp152_] = FALSE;
					}
				}
			}
		} else {
			gboolean _tmp153_ = FALSE;
			ChessPiece* _tmp154_;
			_tmp154_ = victim;
			if (_tmp154_ != NULL) {
				ChessPiece* _tmp155_;
				PieceType _tmp156_;
				_tmp155_ = victim;
				_tmp156_ = _tmp155_->type;
				_tmp153_ = _tmp156_ == PIECE_TYPE_ROOK;
			} else {
				_tmp153_ = FALSE;
			}
			if (_tmp153_) {
				gint _tmp157_ = 0;
				Color _tmp158_;
				gint base_rank = 0;
				gint _tmp159_;
				_tmp158_ = opponent_color;
				if (_tmp158_ == COLOR_WHITE) {
					_tmp157_ = 0;
				} else {
					_tmp157_ = 7;
				}
				base_rank = _tmp157_;
				_tmp159_ = base_rank;
				if (r1 == _tmp159_) {
					if (f1 == 0) {
						Color _tmp160_;
						_tmp160_ = opponent_color;
						self->can_castle_queenside[_tmp160_] = FALSE;
					} else {
						if (f1 == 7) {
							Color _tmp161_;
							_tmp161_ = opponent_color;
							self->can_castle_kingside[_tmp161_] = FALSE;
						}
					}
				}
			}
		}
	}
	_tmp163_ = piece;
	_tmp164_ = _tmp163_->type;
	if (_tmp164_ == PIECE_TYPE_PAWN) {
		gint64 _tmp165_;
		_tmp165_ = over_mask;
		_tmp162_ = _tmp165_ != ((gint64) 0);
	} else {
		_tmp162_ = FALSE;
	}
	if (_tmp162_) {
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
	} else {
		self->en_passant_index = -1;
	}
	_tmp167_ = piece;
	_tmp168_ = _tmp167_->type;
	if (_tmp168_ == PIECE_TYPE_PAWN) {
		_tmp166_ = TRUE;
	} else {
		ChessPiece* _tmp169_;
		_tmp169_ = victim;
		_tmp166_ = _tmp169_ != NULL;
	}
	if (_tmp166_) {
		self->halfmove_clock = 0;
	} else {
		gint _tmp170_;
		_tmp170_ = self->halfmove_clock;
		self->halfmove_clock = _tmp170_ + 1;
	}
	_result_ = TRUE;
	if (test_check) {
		_tmp171_ = chess_state_is_in_check (self, player);
	} else {
		_tmp171_ = FALSE;
	}
	if (_tmp171_) {
		_result_ = FALSE;
	}
	if (!apply) {
		_tmp172_ = TRUE;
	} else {
		gboolean _tmp173_;
		_tmp173_ = _result_;
		_tmp172_ = !_tmp173_;
	}
	if (_tmp172_) {
		gint _tmp174_;
		ChessPiece* _tmp175_;
		ChessPiece* _tmp176_;
		gint _tmp177_;
		ChessPiece* _tmp178_;
		gint _tmp182_;
		gint64 _tmp190_;
		gint64 _tmp191_;
		gboolean _tmp192_;
		gboolean _tmp193_;
		gboolean _tmp194_;
		gboolean _tmp195_;
		gint _tmp196_;
		gint _tmp197_;
		_tmp174_ = start;
		_tmp175_ = piece;
		_tmp176_ = _g_object_ref0 (_tmp175_);
		_g_object_unref0 (self->board[_tmp174_]);
		self->board[_tmp174_] = _tmp176_;
		_tmp177_ = end;
		_g_object_unref0 (self->board[_tmp177_]);
		self->board[_tmp177_] = NULL;
		_tmp178_ = victim;
		if (_tmp178_ != NULL) {
			gint _tmp179_;
			ChessPiece* _tmp180_;
			ChessPiece* _tmp181_;
			_tmp179_ = victim_index;
			_tmp180_ = victim;
			_tmp181_ = _g_object_ref0 (_tmp180_);
			_g_object_unref0 (self->board[_tmp179_]);
			self->board[_tmp179_] = _tmp181_;
		}
		_tmp182_ = rook_start;
		if (_tmp182_ >= 0) {
			ChessPiece* rook = NULL;
			gint _tmp183_;
			ChessPiece* _tmp184_;
			ChessPiece* _tmp185_;
			gint _tmp186_;
			ChessPiece* _tmp187_;
			ChessPiece* _tmp188_;
			gint _tmp189_;
			_tmp183_ = rook_end;
			_tmp184_ = self->board[_tmp183_];
			_tmp185_ = _g_object_ref0 (_tmp184_);
			rook = _tmp185_;
			_tmp186_ = rook_start;
			_tmp187_ = rook;
			_tmp188_ = _g_object_ref0 (_tmp187_);
			_g_object_unref0 (self->board[_tmp186_]);
			self->board[_tmp186_] = _tmp188_;
			_tmp189_ = rook_end;
			_g_object_unref0 (self->board[_tmp189_]);
			self->board[_tmp189_] = NULL;
			_g_object_unref0 (rook);
		}
		_tmp190_ = old_white_mask;
		self->priv->piece_masks[COLOR_WHITE] = _tmp190_;
		_tmp191_ = old_black_mask;
		self->priv->piece_masks[COLOR_BLACK] = _tmp191_;
		_tmp192_ = old_white_can_castle_kingside;
		self->can_castle_kingside[COLOR_WHITE] = _tmp192_;
		_tmp193_ = old_white_can_castle_queenside;
		self->can_castle_queenside[COLOR_WHITE] = _tmp193_;
		_tmp194_ = old_black_can_castle_kingside;
		self->can_castle_kingside[COLOR_BLACK] = _tmp194_;
		_tmp195_ = old_black_can_castle_queenside;
		self->can_castle_queenside[COLOR_BLACK] = _tmp195_;
		_tmp196_ = old_en_passant_index;
		self->en_passant_index = _tmp196_;
		_tmp197_ = old_halfmove_clock;
		self->halfmove_clock = _tmp197_;
		result = _result_;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	_tmp199_ = color;
	if (_tmp199_ == COLOR_WHITE) {
		ChessPlayer* _tmp200_;
		_tmp200_ = self->players[COLOR_BLACK];
		_tmp198_ = _tmp200_;
	} else {
		ChessPlayer* _tmp201_;
		_tmp201_ = self->players[COLOR_WHITE];
		_tmp198_ = _tmp201_;
	}
	_tmp202_ = _g_object_ref0 (_tmp198_);
	_g_object_unref0 (self->current_player);
	self->current_player = _tmp202_;
	_tmp203_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp203_);
	_tmp204_ = chess_move_new ();
	_g_object_unref0 (self->last_move);
	self->last_move = _tmp204_;
	_tmp205_ = self->last_move;
	_tmp206_ = self->number;
	_tmp205_->number = _tmp206_;
	_tmp207_ = self->last_move;
	_tmp208_ = piece;
	_tmp209_ = _g_object_ref0 (_tmp208_);
	_g_object_unref0 (_tmp207_->piece);
	_tmp207_->piece = _tmp209_;
	_tmp210_ = is_promotion;
	if (_tmp210_) {
		ChessMove* _tmp211_;
		gint _tmp212_;
		ChessPiece* _tmp213_;
		ChessPiece* _tmp214_;
		_tmp211_ = self->last_move;
		_tmp212_ = end;
		_tmp213_ = self->board[_tmp212_];
		_tmp214_ = _g_object_ref0 (_tmp213_);
		_g_object_unref0 (_tmp211_->promotion_piece);
		_tmp211_->promotion_piece = _tmp214_;
	}
	_tmp215_ = self->last_move;
	_tmp216_ = victim;
	_tmp217_ = _g_object_ref0 (_tmp216_);
	_g_object_unref0 (_tmp215_->victim);
	_tmp215_->victim = _tmp217_;
	_tmp218_ = rook_end;
	if (_tmp218_ >= 0) {
		ChessMove* _tmp219_;
		gint _tmp220_;
		ChessPiece* _tmp221_;
		ChessPiece* _tmp222_;
		_tmp219_ = self->last_move;
		_tmp220_ = rook_end;
		_tmp221_ = self->board[_tmp220_];
		_tmp222_ = _g_object_ref0 (_tmp221_);
		_g_object_unref0 (_tmp219_->castling_rook);
		_tmp219_->castling_rook = _tmp222_;
	}
	_tmp223_ = self->last_move;
	_tmp223_->r0 = r0;
	_tmp224_ = self->last_move;
	_tmp224_->f0 = f0;
	_tmp225_ = self->last_move;
	_tmp225_->r1 = r1;
	_tmp226_ = self->last_move;
	_tmp226_->f1 = f1;
	_tmp227_ = self->last_move;
	_tmp228_ = ambiguous_rank;
	_tmp227_->ambiguous_rank = _tmp228_;
	_tmp229_ = self->last_move;
	_tmp230_ = ambiguous_file;
	_tmp229_->ambiguous_file = _tmp230_;
	_tmp231_ = self->last_move;
	_tmp232_ = en_passant;
	_tmp231_->en_passant = _tmp232_;
	_tmp233_ = self->last_move;
	_tmp234_ = self->check_state;
	_tmp233_->check_state = _tmp234_;
	result = TRUE;
	_g_object_unref0 (victim);
	_g_object_unref0 (piece);
	return result;
}


ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessResult result = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
	g_return_val_if_fail (self != NULL, 0);
	_vala_rule = CHESS_RULE_CHECKMATE;
	_tmp0_ = self->check_state;
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
		ChessPlayer* _tmp1_;
		Color _tmp2_;
		_tmp1_ = self->current_player;
		_tmp2_ = _tmp1_->color;
		if (_tmp2_ == COLOR_WHITE) {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_BLACK_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		} else {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_WHITE_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		}
	}
	_tmp3_ = self->current_player;
	if (!chess_state_can_move (self, _tmp3_)) {
		_vala_rule = CHESS_RULE_STALEMATE;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	_tmp6_ = self->last_move;
	if (_tmp6_ != NULL) {
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
		_tmp7_ = self->last_move;
		_tmp8_ = _tmp7_->victim;
		_tmp5_ = _tmp8_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = !chess_state_have_sufficient_material (self);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	result = CHESS_RESULT_IN_PROGRESS;
	if (rule) {
		*rule = _vala_rule;
	}
	return result;
}


static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (player != NULL, 0);
	if (chess_state_is_in_check (self, player)) {
		if (chess_state_is_in_checkmate (self, player)) {
			result = CHECK_STATE_CHECKMATE;
			return result;
		} else {
			result = CHECK_STATE_CHECK;
			return result;
		}
	}
	result = CHECK_STATE_NONE;
	return result;
}


gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	_tmp1_ = player->color;
	if (_tmp1_ == COLOR_WHITE) {
		ChessPlayer* _tmp2_;
		_tmp2_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp2_;
	} else {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp0_);
	opponent = _tmp4_;
	{
		gint king_index = 0;
		king_index = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				ChessPiece* p = NULL;
				gint _tmp8_;
				ChessPiece* _tmp9_;
				ChessPiece* _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				ChessPiece* _tmp13_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = king_index;
					king_index = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = king_index;
				if (!(_tmp7_ < 64)) {
					break;
				}
				_tmp8_ = king_index;
				_tmp9_ = self->board[_tmp8_];
				_tmp10_ = _g_object_ref0 (_tmp9_);
				p = _tmp10_;
				_tmp13_ = p;
				if (_tmp13_ != NULL) {
					ChessPiece* _tmp14_;
					ChessPlayer* _tmp15_;
					_tmp14_ = p;
					_tmp15_ = _tmp14_->player;
					_tmp12_ = _tmp15_ == player;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					ChessPiece* _tmp16_;
					PieceType _tmp17_;
					_tmp16_ = p;
					_tmp17_ = _tmp16_->type;
					_tmp11_ = _tmp17_ == PIECE_TYPE_KING;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					{
						gint start = 0;
						start = 0;
						{
							gboolean _tmp18_ = FALSE;
							_tmp18_ = TRUE;
							while (TRUE) {
								gint _tmp20_;
								ChessPlayer* _tmp21_;
								gint _tmp22_;
								gint _tmp23_;
								gint _tmp24_;
								gint _tmp25_;
								if (!_tmp18_) {
									gint _tmp19_;
									_tmp19_ = start;
									start = _tmp19_ + 1;
								}
								_tmp18_ = FALSE;
								_tmp20_ = start;
								if (!(_tmp20_ < 64)) {
									break;
								}
								_tmp21_ = opponent;
								_tmp22_ = start;
								_tmp23_ = start;
								_tmp24_ = king_index;
								_tmp25_ = king_index;
								if (chess_state_move_with_coords (self, _tmp21_, chess_state_get_rank (self, _tmp22_), chess_state_get_file (self, _tmp23_), chess_state_get_rank (self, _tmp24_), chess_state_get_file (self, _tmp25_), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
									result = TRUE;
									_g_object_unref0 (p);
									_g_object_unref0 (opponent);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (opponent);
	return result;
}


static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	{
		gint piece_index = 0;
		piece_index = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = piece_index;
					piece_index = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = piece_index;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = piece_index;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp7_ = p;
				if (_tmp7_ != NULL) {
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
					_tmp8_ = p;
					_tmp9_ = _tmp8_->player;
					_tmp6_ = _tmp9_ == player;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp10_ = FALSE;
							_tmp10_ = TRUE;
							while (TRUE) {
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
								if (!_tmp10_) {
									gint _tmp11_;
									_tmp11_ = end;
									end = _tmp11_ + 1;
								}
								_tmp10_ = FALSE;
								_tmp12_ = end;
								if (!(_tmp12_ < 64)) {
									break;
								}
								_tmp13_ = piece_index;
								_tmp14_ = piece_index;
								_tmp15_ = end;
								_tmp16_ = end;
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = FALSE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = TRUE;
	return result;
}


gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean have_pieces = FALSE;
	gboolean _tmp17_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	have_pieces = FALSE;
	{
		gint start = 0;
		start = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = start;
					start = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = start;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = start;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp7_ = p;
				if (_tmp7_ != NULL) {
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
					_tmp8_ = p;
					_tmp9_ = _tmp8_->player;
					_tmp6_ = _tmp9_ == player;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					have_pieces = TRUE;
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp10_ = FALSE;
							_tmp10_ = TRUE;
							while (TRUE) {
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
								if (!_tmp10_) {
									gint _tmp11_;
									_tmp11_ = end;
									end = _tmp11_ + 1;
								}
								_tmp10_ = FALSE;
								_tmp12_ = end;
								if (!(_tmp12_ < 64)) {
									break;
								}
								_tmp13_ = start;
								_tmp14_ = start;
								_tmp15_ = end;
								_tmp16_ = end;
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = TRUE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	_tmp17_ = have_pieces;
	if (_tmp17_) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}


gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gboolean result = FALSE;
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	white_knight_count = 0;
	white_bishop_count = 0;
	white_bishop_on_white_square = FALSE;
	white_bishop_on_black_square = FALSE;
	black_knight_count = 0;
	black_bishop_count = 0;
	black_bishop_on_white_square = FALSE;
	black_bishop_on_black_square = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				ChessPiece* _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				ChessPiece* _tmp9_;
				PieceType _tmp10_;
				ChessPiece* _tmp15_;
				PieceType _tmp16_;
				ChessPiece* _tmp22_;
				PieceType _tmp23_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gboolean _tmp39_ = FALSE;
				gint _tmp40_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_;
				gboolean _tmp48_ = FALSE;
				gboolean _tmp49_ = FALSE;
				gint _tmp50_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				gint _tmp55_;
				gboolean _tmp58_ = FALSE;
				gint _tmp59_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = i;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp6_ = p;
				if (_tmp6_ == NULL) {
					_g_object_unref0 (p);
					continue;
				}
				_tmp9_ = p;
				_tmp10_ = _tmp9_->type;
				if (_tmp10_ == PIECE_TYPE_PAWN) {
					_tmp8_ = TRUE;
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
					_tmp11_ = p;
					_tmp12_ = _tmp11_->type;
					_tmp8_ = _tmp12_ == PIECE_TYPE_ROOK;
				}
				if (_tmp8_) {
					_tmp7_ = TRUE;
				} else {
					ChessPiece* _tmp13_;
					PieceType _tmp14_;
					_tmp13_ = p;
					_tmp14_ = _tmp13_->type;
					_tmp7_ = _tmp14_ == PIECE_TYPE_QUEEN;
				}
				if (_tmp7_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp15_ = p;
				_tmp16_ = _tmp15_->type;
				if (_tmp16_ == PIECE_TYPE_KNIGHT) {
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
					_tmp17_ = p;
					_tmp18_ = chess_piece_get_color (_tmp17_);
					_tmp19_ = _tmp18_;
					if (_tmp19_ == COLOR_WHITE) {
						gint _tmp20_;
						_tmp20_ = white_knight_count;
						white_knight_count = _tmp20_ + 1;
					} else {
						gint _tmp21_;
						_tmp21_ = black_knight_count;
						black_knight_count = _tmp21_ + 1;
					}
				}
				_tmp22_ = p;
				_tmp23_ = _tmp22_->type;
				if (_tmp23_ == PIECE_TYPE_BISHOP) {
					Color color = 0;
					gint _tmp24_;
					gint _tmp25_;
					ChessPiece* _tmp26_;
					Color _tmp27_;
					Color _tmp28_;
					color = COLOR_BLACK;
					_tmp24_ = i;
					_tmp25_ = i;
					if (((_tmp24_ + (_tmp25_ / 8)) % 2) != 0) {
						color = COLOR_WHITE;
					}
					_tmp26_ = p;
					_tmp27_ = chess_piece_get_color (_tmp26_);
					_tmp28_ = _tmp27_;
					if (_tmp28_ == COLOR_WHITE) {
						Color _tmp29_;
						gint _tmp30_;
						_tmp29_ = color;
						if (_tmp29_ == COLOR_WHITE) {
							white_bishop_on_white_square = TRUE;
						} else {
							white_bishop_on_black_square = TRUE;
						}
						_tmp30_ = white_bishop_count;
						white_bishop_count = _tmp30_ + 1;
					} else {
						Color _tmp31_;
						gint _tmp32_;
						_tmp31_ = color;
						if (_tmp31_ == COLOR_WHITE) {
							black_bishop_on_white_square = TRUE;
						} else {
							black_bishop_on_black_square = TRUE;
						}
						_tmp32_ = black_bishop_count;
						black_bishop_count = _tmp32_ + 1;
					}
				}
				_tmp34_ = white_knight_count;
				if (_tmp34_ > 1) {
					_tmp33_ = TRUE;
				} else {
					gint _tmp35_;
					_tmp35_ = black_knight_count;
					_tmp33_ = _tmp35_ > 1;
				}
				if (_tmp33_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp37_ = white_bishop_count;
				if (_tmp37_ > 0) {
					gint _tmp38_;
					_tmp38_ = white_knight_count;
					_tmp36_ = _tmp38_ > 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp40_ = black_bishop_count;
				if (_tmp40_ > 0) {
					gint _tmp41_;
					_tmp41_ = black_knight_count;
					_tmp39_ = _tmp41_ > 0;
				} else {
					_tmp39_ = FALSE;
				}
				if (_tmp39_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp43_ = white_bishop_on_white_square;
				if (_tmp43_) {
					gboolean _tmp44_;
					_tmp44_ = white_bishop_on_black_square;
					_tmp42_ = _tmp44_;
				} else {
					_tmp42_ = FALSE;
				}
				if (_tmp42_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp46_ = black_bishop_on_white_square;
				if (_tmp46_) {
					gboolean _tmp47_;
					_tmp47_ = black_bishop_on_black_square;
					_tmp45_ = _tmp47_;
				} else {
					_tmp45_ = FALSE;
				}
				if (_tmp45_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp50_ = white_bishop_count;
				if (_tmp50_ > 0) {
					_tmp49_ = TRUE;
				} else {
					gint _tmp51_;
					_tmp51_ = white_knight_count;
					_tmp49_ = _tmp51_ > 0;
				}
				if (_tmp49_) {
					gint _tmp52_;
					_tmp52_ = black_knight_count;
					_tmp48_ = _tmp52_ > 0;
				} else {
					_tmp48_ = FALSE;
				}
				if (_tmp48_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp55_ = black_bishop_count;
				if (_tmp55_ > 0) {
					_tmp54_ = TRUE;
				} else {
					gint _tmp56_;
					_tmp56_ = black_knight_count;
					_tmp54_ = _tmp56_ > 0;
				}
				if (_tmp54_) {
					gint _tmp57_;
					_tmp57_ = white_knight_count;
					_tmp53_ = _tmp57_ > 0;
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp59_ = white_bishop_count;
				if (_tmp59_ > 0) {
					gint _tmp60_;
					_tmp60_ = black_bishop_count;
					_tmp58_ = _tmp60_ > 0;
				} else {
					_tmp58_ = FALSE;
				}
				if (_tmp58_) {
					gboolean _tmp61_ = FALSE;
					gboolean _tmp62_;
					_tmp62_ = white_bishop_on_white_square;
					if (_tmp62_) {
						gboolean _tmp63_;
						_tmp63_ = black_bishop_on_black_square;
						_tmp61_ = _tmp63_;
					} else {
						_tmp61_ = FALSE;
					}
					if (_tmp61_) {
						result = TRUE;
						_g_object_unref0 (p);
						return result;
					} else {
						gboolean _tmp64_ = FALSE;
						gboolean _tmp65_;
						_tmp65_ = white_bishop_on_black_square;
						if (_tmp65_) {
							gboolean _tmp66_;
							_tmp66_ = black_bishop_on_white_square;
							_tmp64_ = _tmp66_;
						} else {
							_tmp64_ = FALSE;
						}
						if (_tmp64_) {
							result = TRUE;
							_g_object_unref0 (p);
							return result;
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	return result;
}


static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_type = PIECE_TYPE_PAWN;
	switch (c) {
		case 'P':
		{
			_vala_type = PIECE_TYPE_PAWN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'R':
		{
			_vala_type = PIECE_TYPE_ROOK;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'N':
		{
			_vala_type = PIECE_TYPE_KNIGHT;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'B':
		{
			_vala_type = PIECE_TYPE_BISHOP;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'Q':
		{
			_vala_type = PIECE_TYPE_QUEEN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'K':
		{
			_vala_type = PIECE_TYPE_KING;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		default:
		{
			result = FALSE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
	}
	if (type) {
		*type = _vala_type;
	}
}


static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gboolean result = FALSE;
	gint i = 0;
	gint _tmp99_;
	gint _tmp103_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	i = 0;
	_vala_promotion_type = PIECE_TYPE_QUEEN;
	if (g_str_has_prefix (move, "O-O-O")) {
		Color _tmp0_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		_tmp0_ = player->color;
		if (_tmp0_ == COLOR_WHITE) {
			gint _tmp1_;
			_vala_r1 = 0;
			_tmp1_ = _vala_r1;
			_vala_r0 = _tmp1_;
		} else {
			gint _tmp2_;
			_vala_r1 = 7;
			_tmp2_ = _vala_r1;
			_vala_r0 = _tmp2_;
		}
		_vala_f0 = 4;
		_vala_f1 = 2;
		_tmp3_ = i;
		_tmp4_ = strlen ("O-O-O");
		_tmp5_ = _tmp4_;
		i = _tmp3_ + ((gint) _tmp5_);
	} else {
		if (g_str_has_prefix (move, "O-O")) {
			Color _tmp6_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp6_ = player->color;
			if (_tmp6_ == COLOR_WHITE) {
				gint _tmp7_;
				_vala_r1 = 0;
				_tmp7_ = _vala_r1;
				_vala_r0 = _tmp7_;
			} else {
				gint _tmp8_;
				_vala_r1 = 7;
				_tmp8_ = _vala_r1;
				_vala_r0 = _tmp8_;
			}
			_vala_f0 = 4;
			_vala_f1 = 6;
			_tmp9_ = i;
			_tmp10_ = strlen ("O-O");
			_tmp11_ = _tmp10_;
			i = _tmp9_ + ((gint) _tmp11_);
		} else {
			PieceType type = 0;
			gint _tmp12_;
			PieceType _tmp13_ = 0;
			gboolean _tmp14_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			gboolean _tmp24_ = FALSE;
			gint _tmp25_;
			gboolean _tmp29_ = FALSE;
			gint _tmp30_;
			gboolean _tmp33_ = FALSE;
			gint _tmp34_;
			gboolean _tmp39_ = FALSE;
			gint _tmp40_;
			gint _tmp45_;
			gboolean _tmp57_ = FALSE;
			gint _tmp58_;
			gboolean _tmp60_ = FALSE;
			gint _tmp61_;
			type = PIECE_TYPE_PAWN;
			_tmp12_ = i;
			_tmp14_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp12_), &_tmp13_);
			type = _tmp13_;
			if (_tmp14_) {
				gint _tmp15_;
				_tmp15_ = i;
				i = _tmp15_ + 1;
			}
			_vala_f1 = -1;
			_tmp16_ = _vala_f1;
			_vala_r1 = _tmp16_;
			_tmp17_ = _vala_r1;
			_vala_f0 = _tmp17_;
			_tmp18_ = _vala_f0;
			_vala_r0 = _tmp18_;
			_tmp20_ = i;
			if (string_get (move, (glong) _tmp20_) >= 'a') {
				gint _tmp21_;
				_tmp21_ = i;
				_tmp19_ = string_get (move, (glong) _tmp21_) <= 'h';
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				gint _tmp22_;
				gint _tmp23_;
				_tmp22_ = i;
				_vala_f1 = (gint) (string_get (move, (glong) _tmp22_) - 'a');
				_tmp23_ = i;
				i = _tmp23_ + 1;
			}
			_tmp25_ = i;
			if (string_get (move, (glong) _tmp25_) >= '1') {
				gint _tmp26_;
				_tmp26_ = i;
				_tmp24_ = string_get (move, (glong) _tmp26_) <= '8';
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				gint _tmp27_;
				gint _tmp28_;
				_tmp27_ = i;
				_vala_r1 = (gint) (string_get (move, (glong) _tmp27_) - '1');
				_tmp28_ = i;
				i = _tmp28_ + 1;
			}
			_tmp30_ = i;
			if (string_get (move, (glong) _tmp30_) == 'x') {
				_tmp29_ = TRUE;
			} else {
				gint _tmp31_;
				_tmp31_ = i;
				_tmp29_ = string_get (move, (glong) _tmp31_) == '-';
			}
			if (_tmp29_) {
				gint _tmp32_;
				_tmp32_ = i;
				i = _tmp32_ + 1;
			}
			_tmp34_ = i;
			if (string_get (move, (glong) _tmp34_) >= 'a') {
				gint _tmp35_;
				_tmp35_ = i;
				_tmp33_ = string_get (move, (glong) _tmp35_) <= 'h';
			} else {
				_tmp33_ = FALSE;
			}
			if (_tmp33_) {
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				_tmp36_ = _vala_f1;
				_vala_f0 = _tmp36_;
				_tmp37_ = i;
				_vala_f1 = (gint) (string_get (move, (glong) _tmp37_) - 'a');
				_tmp38_ = i;
				i = _tmp38_ + 1;
			}
			_tmp40_ = i;
			if (string_get (move, (glong) _tmp40_) >= '1') {
				gint _tmp41_;
				_tmp41_ = i;
				_tmp39_ = string_get (move, (glong) _tmp41_) <= '8';
			} else {
				_tmp39_ = FALSE;
			}
			if (_tmp39_) {
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				_tmp42_ = _vala_r1;
				_vala_r0 = _tmp42_;
				_tmp43_ = i;
				_vala_r1 = (gint) (string_get (move, (glong) _tmp43_) - '1');
				_tmp44_ = i;
				i = _tmp44_ + 1;
			}
			_tmp45_ = i;
			if (string_get (move, (glong) _tmp45_) == '=') {
				gint _tmp46_;
				gint _tmp47_;
				PieceType _tmp48_ = 0;
				gboolean _tmp49_;
				_tmp46_ = i;
				i = _tmp46_ + 1;
				_tmp47_ = i;
				_tmp49_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp47_), &_tmp48_);
				_vala_promotion_type = _tmp48_;
				if (_tmp49_) {
					gint _tmp50_;
					_tmp50_ = i;
					i = _tmp50_ + 1;
				}
			} else {
				gint _tmp51_;
				_tmp51_ = i;
				if (string_get (move, (glong) _tmp51_) != '\0') {
					gint _tmp52_;
					_tmp52_ = i;
					switch (string_get (move, (glong) _tmp52_)) {
						case 'q':
						case 'Q':
						{
							gint _tmp53_;
							_vala_promotion_type = PIECE_TYPE_QUEEN;
							_tmp53_ = i;
							i = _tmp53_ + 1;
							break;
						}
						case 'n':
						case 'N':
						{
							gint _tmp54_;
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
							_tmp54_ = i;
							i = _tmp54_ + 1;
							break;
						}
						case 'r':
						case 'R':
						{
							gint _tmp55_;
							_vala_promotion_type = PIECE_TYPE_ROOK;
							_tmp55_ = i;
							i = _tmp55_ + 1;
							break;
						}
						case 'b':
						case 'B':
						{
							gint _tmp56_;
							_vala_promotion_type = PIECE_TYPE_BISHOP;
							_tmp56_ = i;
							i = _tmp56_ + 1;
							break;
						}
						default:
						break;
					}
				}
			}
			_tmp58_ = _vala_r1;
			if (_tmp58_ < 0) {
				_tmp57_ = TRUE;
			} else {
				gint _tmp59_;
				_tmp59_ = _vala_f1;
				_tmp57_ = _tmp59_ < 0;
			}
			if (_tmp57_) {
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
				result = FALSE;
				if (r0) {
					*r0 = _vala_r0;
				}
				if (f0) {
					*f0 = _vala_f0;
				}
				if (r1) {
					*r1 = _vala_r1;
				}
				if (f1) {
					*f1 = _vala_f1;
				}
				if (promotion_type) {
					*promotion_type = _vala_promotion_type;
				}
				return result;
			}
			_tmp61_ = _vala_r0;
			if (_tmp61_ < 0) {
				_tmp60_ = TRUE;
			} else {
				gint _tmp62_;
				_tmp62_ = _vala_f0;
				_tmp60_ = _tmp62_ < 0;
			}
			if (_tmp60_) {
				gint match_rank = 0;
				gint match_file = 0;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_;
				match_rank = -1;
				match_file = -1;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp63_ = FALSE;
						_tmp63_ = TRUE;
						while (TRUE) {
							gint _tmp65_;
							gboolean _tmp66_ = FALSE;
							gint _tmp67_;
							if (!_tmp63_) {
								gint _tmp64_;
								_tmp64_ = file;
								file = _tmp64_ + 1;
							}
							_tmp63_ = FALSE;
							_tmp65_ = file;
							if (!(_tmp65_ < 8)) {
								break;
							}
							_tmp67_ = _vala_f0;
							if (_tmp67_ >= 0) {
								gint _tmp68_;
								gint _tmp69_;
								_tmp68_ = file;
								_tmp69_ = _vala_f0;
								_tmp66_ = _tmp68_ != _tmp69_;
							} else {
								_tmp66_ = FALSE;
							}
							if (_tmp66_) {
								continue;
							}
							{
								gint rank = 0;
								rank = 0;
								{
									gboolean _tmp70_ = FALSE;
									_tmp70_ = TRUE;
									while (TRUE) {
										gint _tmp72_;
										gboolean _tmp73_ = FALSE;
										gint _tmp74_;
										ChessPiece* piece = NULL;
										gint _tmp77_;
										gint _tmp78_;
										ChessPiece* _tmp79_;
										ChessPiece* _tmp80_;
										gboolean _tmp81_ = FALSE;
										gboolean _tmp82_ = FALSE;
										ChessPiece* _tmp83_;
										gint _tmp89_;
										gint _tmp90_;
										gint _tmp91_;
										gint _tmp92_;
										gint _tmp93_;
										gint _tmp94_;
										gint _tmp95_;
										if (!_tmp70_) {
											gint _tmp71_;
											_tmp71_ = rank;
											rank = _tmp71_ + 1;
										}
										_tmp70_ = FALSE;
										_tmp72_ = rank;
										if (!(_tmp72_ < 8)) {
											break;
										}
										_tmp74_ = _vala_r0;
										if (_tmp74_ >= 0) {
											gint _tmp75_;
											gint _tmp76_;
											_tmp75_ = rank;
											_tmp76_ = _vala_r0;
											_tmp73_ = _tmp75_ != _tmp76_;
										} else {
											_tmp73_ = FALSE;
										}
										if (_tmp73_) {
											continue;
										}
										_tmp77_ = rank;
										_tmp78_ = file;
										_tmp79_ = self->board[chess_state_get_index (self, _tmp77_, _tmp78_)];
										_tmp80_ = _g_object_ref0 (_tmp79_);
										piece = _tmp80_;
										_tmp83_ = piece;
										if (_tmp83_ == NULL) {
											_tmp82_ = TRUE;
										} else {
											ChessPiece* _tmp84_;
											PieceType _tmp85_;
											PieceType _tmp86_;
											_tmp84_ = piece;
											_tmp85_ = _tmp84_->type;
											_tmp86_ = type;
											_tmp82_ = _tmp85_ != _tmp86_;
										}
										if (_tmp82_) {
											_tmp81_ = TRUE;
										} else {
											ChessPiece* _tmp87_;
											ChessPlayer* _tmp88_;
											_tmp87_ = piece;
											_tmp88_ = _tmp87_->player;
											_tmp81_ = _tmp88_ != player;
										}
										if (_tmp81_) {
											_g_object_unref0 (piece);
											continue;
										}
										_tmp89_ = rank;
										_tmp90_ = file;
										_tmp91_ = _vala_r1;
										_tmp92_ = _vala_f1;
										if (!chess_state_move_with_coords (self, player, _tmp89_, _tmp90_, _tmp91_, _tmp92_, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
											_g_object_unref0 (piece);
											continue;
										}
										_tmp93_ = match_rank;
										if (_tmp93_ >= 0) {
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
											result = FALSE;
											_g_object_unref0 (piece);
											if (r0) {
												*r0 = _vala_r0;
											}
											if (f0) {
												*f0 = _vala_f0;
											}
											if (r1) {
												*r1 = _vala_r1;
											}
											if (f1) {
												*f1 = _vala_f1;
											}
											if (promotion_type) {
												*promotion_type = _vala_promotion_type;
											}
											return result;
										}
										_tmp94_ = rank;
										match_rank = _tmp94_;
										_tmp95_ = file;
										match_file = _tmp95_;
										_g_object_unref0 (piece);
									}
								}
							}
						}
					}
				}
				_tmp96_ = match_rank;
				if (_tmp96_ < 0) {
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
					result = FALSE;
					if (r0) {
						*r0 = _vala_r0;
					}
					if (f0) {
						*f0 = _vala_f0;
					}
					if (r1) {
						*r1 = _vala_r1;
					}
					if (f1) {
						*f1 = _vala_f1;
					}
					if (promotion_type) {
						*promotion_type = _vala_promotion_type;
					}
					return result;
				}
				_tmp97_ = match_rank;
				_vala_r0 = _tmp97_;
				_tmp98_ = match_file;
				_vala_f0 = _tmp98_;
			}
		}
	}
	_tmp99_ = i;
	if (string_get (move, (glong) _tmp99_) == '+') {
		gint _tmp100_;
		_tmp100_ = i;
		i = _tmp100_ + 1;
	} else {
		gint _tmp101_;
		_tmp101_ = i;
		if (string_get (move, (glong) _tmp101_) == '#') {
			gint _tmp102_;
			_tmp102_ = i;
			i = _tmp102_ + 1;
		}
	}
	_tmp103_ = i;
	if (string_get (move, (glong) _tmp103_) != '\0') {
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
		result = FALSE;
		if (r0) {
			*r0 = _vala_r0;
		}
		if (f0) {
			*f0 = _vala_f0;
		}
		if (r1) {
			*r1 = _vala_r1;
		}
		if (f1) {
			*f1 = _vala_f1;
		}
		if (promotion_type) {
			*promotion_type = _vala_promotion_type;
		}
		return result;
	}
	result = TRUE;
	if (r0) {
		*r0 = _vala_r0;
	}
	if (f0) {
		*f0 = _vala_f0;
	}
	if (r1) {
		*r1 = _vala_r1;
	}
	if (f1) {
		*f1 = _vala_f1;
	}
	if (promotion_type) {
		*promotion_type = _vala_promotion_type;
	}
	return result;
}


ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->current_player;
	_tmp2_ = _tmp1_->color;
	if (_tmp2_ == COLOR_WHITE) {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp3_;
	} else {
		ChessPlayer* _tmp4_;
		_tmp4_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}


static void
chess_state_class_init (ChessStateClass * klass)
{
	chess_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ChessStatePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
chess_state_instance_init (ChessState * self)
{
	self->priv = CHESS_STATE_GET_PRIVATE (self);
	self->number = 0;
	self->en_passant_index = -1;
	self->last_move = NULL;
}


static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->current_player);
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->last_move);
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
}


GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}


static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
	switch (property_id) {
		case CHESS_STATE_OPPONENT_PROPERTY:
		g_value_set_object (value, chess_state_get_opponent (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



